From bcc68cec075bfbe5408bc2d3beaee212268f9909 Mon Sep 17 00:00:00 2001
From: Floris Bos <bos@je-eigen-domein.nl>
Date: Tue, 11 Jan 2011 14:20:29 +0100
Subject: [PATCH] Kickstart file with standard disklayout that is known to work with Scientific Linux 6 alpha, and one with software RAID1 that breaks.

---
 centos6-nocps-raid1.cfg    |  105 ++++++++++++++++++++++++++++++++++++++++++++
 centos6-nocps-raid1.sh     |    6 +++
 centos6-nocps-standard.cfg |   85 +++++++++++++++++++++++++++++++++++
 centos6-nocps-standard.sh  |    6 +++
 4 files changed, 202 insertions(+), 0 deletions(-)
 create mode 100644 centos6-nocps-raid1.cfg
 create mode 100755 centos6-nocps-raid1.sh
 create mode 100644 centos6-nocps-standard.cfg
 create mode 100755 centos6-nocps-standard.sh

diff --git a/centos6-nocps-raid1.cfg b/centos6-nocps-raid1.cfg
new file mode 100644
index 0000000..2293fcc
--- /dev/null
+++ b/centos6-nocps-raid1.cfg
@@ -0,0 +1,105 @@
+#
+# WARNING: the disklayout used in this kickstart script gives an error on the Scientific Linux 6 alpha version. ("new lv is too large to fit in free space")
+# The same disklayout works fine in Centos 5.5 though, so I'm submitting this script as a test case nevertheless
+# (if you would like to test it with Centos 5.5, you can use this script, but remove the "%end" lines)
+#
+#
+# Kickstart script generated by our commercial server provisioning software ( http://www.noc-ps.com )
+#
+# Settings used:
+#
+# Disk layout: Soft. RAID1 (2 disks sda sdb)
+# Packages: NOC-PS default (installs local resolving nameserver + SSH)
+# IP/Netmask/Gateway: 10.0.0.100 / 255.255.255.0 / 10.0.0.1
+# Root password: centostest
+# Regular user name: charlie
+# Regular user password: centostest
+#
+#
+# If you change the network settings: please leave the nameserver at 127.0.0.1
+# and specify installation source by IP instead of hostname.
+#
+# After installation BIND is used as local resolving nameserver, so no dependencies
+# exists on other systems
+#
+
+
+#System language
+lang en_US
+#Language modules to install
+#langsupport en_US
+#System keyboard
+keyboard us
+#System mouse
+#mouse none
+#System timezone
+timezone Europe/Amsterdam
+#Root password
+rootpw --iscrypted "$1$tEc7zWwN$03s7xjno7IE6mndUQy1E71"
+
+user --name "charlie" --iscrypted --password "$1$Z2lV1KN3$Nt0/U9cp74UJJjMNUpn9H/"
+#Reboot after installation
+reboot
+#Use text mode install
+text
+#Install OS instead of upgrade
+install
+#Use Web installation
+
+#url --url http://131.225.110.41/linux/scientific/6rolling/x86_64/os/
+
+#System bootloader configuration
+bootloader --location=mbr 
+#Clear the Master Boot Record
+#zerombr yes
+zerombr
+#Partition clearing information
+clearpart --all --initlabel 
+#Disk partitioning information
+
+# Disks for 250 MB boot partition
+
+part raid.01 --size=250 --asprimary --ondisk=sda
+part raid.02 --size=250 --asprimary --ondisk=sdb
+
+# Disks for LVM partition
+
+part raid.11 --size=1 --grow --ondisk=sda
+part raid.12 --size=1 --grow --ondisk=sdb
+
+# RAID settings
+
+raid /boot --fstype ext2 --device md0 --level=RAID1 raid.01 raid.02
+raid pv.01 --device md1 --level=RAID1 raid.11 raid.12
+
+# LVM configuration
+
+volgroup vg pv.01
+logvol / --vgname=vg --size=1 --grow --fstype ext3 --name=root
+logvol /tmp --vgname=vg --size=1024 --fstype ext3 --name=tmp
+logvol swap --vgname=vg --recommended --name=swap
+#System authorization infomation
+auth  --useshadow  --enablemd5 
+#Network information
+network --bootproto=static --ip=10.0.0.100 --netmask=255.255.255.0 --gateway=10.0.0.1 --nameserver=127.0.0.1 --device=eth0 --hostname=centos6test.noc-ps.com
+#Firewall configuration
+firewall --disabled 
+#Do not configure the X Window System
+skipx
+
+#%packages --resolvedeps
+%packages
+
+openssh-server
+caching-nameserver
+
+%end
+%pre
+
+
+%end
+%post
+
+chkconfig named on
+
+%end
\ No newline at end of file
diff --git a/centos6-nocps-raid1.sh b/centos6-nocps-raid1.sh
new file mode 100755
index 0000000..163d503
--- /dev/null
+++ b/centos6-nocps-raid1.sh
@@ -0,0 +1,6 @@
+#!/bin/bash
+
+echo "- Test if the DNS works correctly (we installed BIND locally)"
+host www.google.com
+
+exit $?
diff --git a/centos6-nocps-standard.cfg b/centos6-nocps-standard.cfg
new file mode 100644
index 0000000..ce608c7
--- /dev/null
+++ b/centos6-nocps-standard.cfg
@@ -0,0 +1,85 @@
+#
+# Kickstart script generated by our commercial server provisioning software ( http://www.noc-ps.com )
+# This script is known to work with the Scientific Linux 6 alpha.
+#
+# Settings used:
+#
+# Disk layout: default
+# Packages: NOC-PS default (installs local resolving nameserver + SSH)
+# IP/Netmask/Gateway: 10.0.0.100 / 255.255.255.0 / 10.0.0.1
+# Root password: centostest
+# Regular user name: charlie
+# Regular user password: centostest
+#
+#
+# If you change the network settings: please leave the nameserver at 127.0.0.1
+# and specify installation source by IP instead of hostname.
+#
+# After installation BIND is used as local resolving nameserver, so no dependencies
+# exists on other systems
+#
+
+#System language
+lang en_US
+#Language modules to install
+#langsupport en_US
+#System keyboard
+keyboard us
+#System mouse
+#mouse none
+#System timezone
+timezone Europe/Amsterdam
+#Root password
+rootpw --iscrypted "$1$g0LgrMHV$qXwnCy387PxR/Nmcote2V/"
+
+user --name "charlie" --iscrypted --password "$1$vzpx0Hn5$EH5Xfax2MVzxw26xyQmS0."
+#Reboot after installation
+reboot
+#Use text mode install
+text
+#Install OS instead of upgrade
+install
+#Use Web installation
+
+#url --url http://131.225.110.41/linux/scientific/6rolling/x86_64/os/
+
+#System bootloader configuration
+bootloader --location=mbr 
+#Clear the Master Boot Record
+#zerombr yes
+zerombr
+#Partition clearing information
+clearpart --all --initlabel 
+#Disk partitioning information
+
+part /boot --fstype ext2 --size 250
+part pv.01 --size 1 --grow
+volgroup vg pv.01
+logvol / --vgname=vg --size=1 --grow --fstype ext4 --name=root
+logvol /tmp --vgname=vg --size=1024 --fstype ext4 --name=tmp
+logvol swap --vgname=vg --recommended --name=swap
+#System authorization infomation
+auth  --useshadow  --enablemd5 
+#Network information
+network --bootproto=static --ip=10.0.0.100 --netmask=255.255.255.0 --gateway=10.0.0.1 --nameserver=127.0.0.1 --device=eth0 --hostname=centos6test.noc-ps.com
+#Firewall configuration
+firewall --disabled 
+#Do not configure the X Window System
+skipx
+
+#%packages --resolvedeps
+%packages
+
+openssh-server
+caching-nameserver
+
+%end
+%pre
+
+
+%end
+%post
+
+chkconfig named on
+
+%end
\ No newline at end of file
diff --git a/centos6-nocps-standard.sh b/centos6-nocps-standard.sh
new file mode 100755
index 0000000..163d503
--- /dev/null
+++ b/centos6-nocps-standard.sh
@@ -0,0 +1,6 @@
+#!/bin/bash
+
+echo "- Test if the DNS works correctly (we installed BIND locally)"
+host www.google.com
+
+exit $?
-- 
1.7.1